expressjs-domain-parser
=======================

A domain/url parser that breaks apart into components


install
=======

npm

```bash
npm install expressjs-domain-parser --save
```

usage
=====

```javascript
var parse = require('expressjs-domain-parser');
var parsed = parse('http://domainname.com:4080/api/bdd/')

console.log(
  parsed.domain.url          //> "developer.domainname.org:8080" -- host with port number
  , parsed.domain.sld        //> "domain" -- the second part from the right
  , parsed.domain.idn        //> "developer.domainname.org" -- domain name
  , parsed.domain.protocol   //> "https" -- request type
  , parsed.domain.suffix     //> "org" -- ttd name
  , parsed.domain.prefix     //> "developer" -- specific sub domain
  , parsed.domain.port       //> "8080" -- port number
  , parsed.domain.token      //> "DeveloperDomainnameOrg" -- convert domain into key
  , parsed.domain.level(2)   //> "domainname" -- specific sub domain level part, 1 based (tld is level 1)
);
```

license
=======

MIT
