var ParseDomain, exports, wrapper, _;

_ = require('lodash');

wrapper = require('./wrapper');

ParseDomain = function(options) {
  var args, domainUrl, referer;
  args = Array.prototype.slice.call(arguments);
  if (_.isPlainObject(options)) {
    domainUrl = options.domainUrl;
    referer = options.referer;
  } else {
    domainUrl = args[0];
    referer = args[1];
  }
  this.tldList = [];
  this.referer = wrapper(this.parseUrl(referer));
  this.domain = wrapper(this.parseUrl(domainUrl));
  return this;
};

Object.defineProperties(ParseDomain.prototype, {
  parseUrl: {
    writable: false,
    value: function(domainUrl) {
      var parsed;
      if (!domainUrl) {
        return null;
      }
      domainUrl = domainUrl.toLowerCase().trim();
      parsed = /^((http|https|ftp|ftps|news|ssh|sftp|gopher):[\/]{2,})?([^\/]+)/.exec(domainUrl);
      return {
        url: parsed[0],
        idn: parsed[1],
        protocol: parsed[2],
        name: parsed[3],
        uri: parsed['input']
      };
    }
  }
});

exports = module.exports = ParseDomain;
