_ = require 'lodash'
wrapper = require './wrapper'

ParseDomain = (options) ->
  args = Array.prototype.slice.call arguments

  if _.isPlainObject options
    domainUrl = options.domainUrl
    referer = options.referer
  else
    domainUrl = args[0]
    referer = args[1]

  @tldList = []
  @referer = wrapper @parseUrl referer
  @domain = wrapper @parseUrl domainUrl

  return this


Object.defineProperties ParseDomain.prototype,
  parseUrl:
    writable: false
    value: (domainUrl) ->
      return null unless domainUrl
      domainUrl = domainUrl.toLowerCase().trim()
      parsed = /^((http|https|ftp|ftps|news|ssh|sftp|gopher):[\/]{2,})?([^\/]+)/.exec(domainUrl)

      url: parsed[0]
      idn: parsed[1]
      protocol: parsed[2]
      name: parsed[3]
      uri: parsed['input']

exports = module.exports = ParseDomain
